Codeforces 766 C Mahmoud and a Message 详解(DP)

来源:互联网 发布:淘宝德芙巧克力 编辑:程序博客网 时间:2024/05/14 13:28



C. Mahmoud and a Message
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That's because this magical paper doesn't allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can't write character 'a' on this paper in a string of length 3 or more. String "aa" is allowed while string "aaa" is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn't overlap. For example, if a1 = 2 and he wants to send string "aaa", he can split it into "a" and "aa" and use 2 magical papers, or into "a", "a" and "a" and use 3 magical papers. He can't split it into "aa" and "aa" because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings "ab", "abc" and "b" are substrings of string "abc", while strings "acb" and "ac" are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

  • How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don't overlap? Compute the answer modulo 109 + 7.
  • What is the maximum length of a substring that can appear in some valid splitting?
  • What is the minimum number of substrings the message can be spit in?

Two ways are considered different, if the sets of split positions differ. For example, splitting "aa|a" and "a|aa" are considered different splittings of message "aaa".

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, ..., a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Examples
input
3aab2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
output
322
input
10abcdeabcde5 5 5 5 4 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
output
40143
Note

In the first example the three ways to split the message are:

  • a|a|b
  • aa|b
  • a|ab

The longest substrings are "aa" and "ab" of length 2.

The minimum number of substrings is 2 in "a|ab" or "aa|b".

Notice that "aab" is not a possible splitting because the letter 'a' appears in a substring of length 3, while a1 = 2.

题意:

给你一个长度为n的字符串; 
这个字符串只包含小写字母; 
然后让你把这个字符串进行分割;形成若干个小的字符串; 
但是不是任意分割的; 
每个小写字母都有一个数字ma[i];表示这个字母能够存在于长度不超过ma[i]的字符串内; 

在这个条件下分割; 



这题想出一半吧。。细节还是错了一些,还是菜。。。就是怎么判断这个这个单词是不是每个单词的长度都符合。。。想写一个check函数的。。最后模仿q巨的写法。。



思路:xjbdp,对于每一个字符有两种来源,一个是自己组成一段,一个是与前面某几个字符组成一段(老生长谈了。。),对于方案数,自己组成一段,方案数就是+= 前i-1的方案数,如果与前面一个字符组成一段,就是+=前i-2,同理与前2个前3个。。判断这组成一段的字符,是不是每个字符都符合条件,这里用一个limit记录这一段所有字符中“最短的限制”,其实也就是这一段的限制。。求最长的一段,就是比较当前这一段,跟这一段之前的最大值。。(这里卡了一会,,),求最小的段数,就是这一段之前的+1.。代码很简单,看代码差不多就会了。。

#include <iostream>#include <algorithm>#include <cstring>#include <cstdio>using namespace std;const int maxn = 1e3 + 5;const int Mod = 1e9 + 7;int dp[3][maxn], a[30];char str[maxn];int main(){    int n;    cin >> n;    scanf("%s", str+1);    for(int i = 1; i <= n; i++)    {        dp[1][i] = -1;        dp[2][i] = maxn;    }    for(int i = 0; i < 26; i++)        cin >> a[i];    dp[2][0] = 0;  //下面转移方程有i-1,所以str从1开始,把0初始化    dp[0][0] = 1;    for(int i = 1; i <= n; i++)    {        int limit = a[str[i]-'a'];  //这里是精髓        for(int j = i; j >= 1; j--)        {            limit = min(limit, a[str[j]-'a']);  //找出每个字符最短的            if(i-j+1>limit) break;  //如果不符合,就跳出,最后一个字符,与后面的几个组成,不能挎着组合            dp[0][i] = (dp[0][i] + dp[0][j-1]) % Mod;  //一直到跳出,这些都是一些方案            dp[1][i] = max(dp[1][j-1], max(dp[1][i], i-j+1));  //有两个max,一定要与j-1相比较            dp[2][i] = min(dp[2][i], dp[2][j-1]+1);  //前面的段数+1        }    }    for(int i = 0; i < 3; i++)        cout << dp[i][n] << endl;    return 0;}


1 0